#! /usr/bin/perl -w
use FindBin;
use lib "$FindBin::Bin/../lib";
use Pastel;

use strict;

my $point1 = Pastel::Geometry::Point->new(2,4);
my $point2 = Pastel::Geometry::Point->new(8,7);
my $line1 = Pastel::Geometry::Line->new(2, 4, 8, 7);
my $line2 = Pastel::Geometry::Line->new(-x1=>2, -x2=>8, -y1=>4, -y2=>7);
my $line3 = Pastel::Geometry::Line->new($point1, $point2);
print $line1->get_p1()->to_string(), "\n";
print $line1->get_p2()->to_string(), "\n";
print $line3->get_p1()->to_string(), "\n";
print $line3->get_p2()->to_string(), "\n";
print $line2->get_p1()->to_string(), "\n";
print $line2->get_p2()->to_string(), "\n";

#Bounding box
my $line4 = Pastel::Geometry::Line->new(100,200  ,  400,500);
my $bb = $line4->get_bounds();
print $bb->to_string(), "\n";
#my $line4->set_stroke(Pastel::BasicStroke->new(width=>2));

my $g2 = Pastel::Graphics->new(-width=>800,-height=>600);
$g2->set_stroke(Pastel::BasicStroke->new(-width=>2));
$g2->set_paint(Pastel::LinearGradient->new(-color1=>Pastel::Color->red(),
					  -color2=>Pastel::Color->blue()));
$g2->draw($line4);
$g2->show();
print $g2->get_svg();


